#include	<stdio.h>

#include	<X11/X.h>
#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include	<X11/cursorfont.h>

#include "wm.h"

Cursor root_cursor;
Cursor frame_cursor;

static struct CursorMapping {
	Edge		edge;
	int		font_char;
	Cursor	cursor;
} cursor_map[] = {

	/*
	 * These *MUST* be in the same order as they appear in wm.h, because
	 * we index rather than search in edgecursor() later on.
	 */

	{ETopLeft,		XC_top_left_corner, 0,},
	{ETop,			XC_top_side, 0,},
	{ETopRight,		XC_top_right_corner, 0,},
	{ERight,			XC_right_side, 0,},
	{ENone,			XC_fleur, 0,},
	{ELeft,			XC_left_side, 0,},
	{EBottomLeft,	XC_bottom_left_corner, 0,},
	{EBottom,		XC_bottom_side, 0,},
	{EBottomRight,	XC_bottom_right_corner, 0,},

	{ENone,			0, 0,},
};

extern void
Cursor_Initialise(void)
{
	XColor red, white, exact;
	Colormap cmp;
	int i;

	cmp = DefaultColormap(dpy, DefaultScreen(dpy));

	XAllocNamedColor(dpy, cmp, "red", &red, &exact);
	XAllocNamedColor(dpy, cmp, "white", &white, &exact);

	root_cursor = XCreateFontCursor(dpy, XC_X_cursor);
	XRecolorCursor(dpy, root_cursor, &red, &white);

	frame_cursor = XCreateFontCursor(dpy, XC_left_ptr);
	XRecolorCursor(dpy, frame_cursor, &red, &white);

	for (i = 0; cursor_map[i].font_char != 0; i++) {
		cursor_map[i].cursor = XCreateFontCursor(dpy, cursor_map[i].font_char);
		XRecolorCursor(dpy, cursor_map[i].cursor, &red, &white);
	}
}

extern Cursor
edgecursor(Edge edge)
{
	return cursor_map[edge].cursor;
}
